#!/usr/bin/perl
require ("./cgi-header.pl") || die "Can't open CGI library: $!";
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (C) 1998, 1999  Sonny Parlin
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
&main;

# Setup a secure environment
$ENV{'PATH'} = '/sbin:/usr/bin:/bin';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};

# Setup some global variables
$IPCHAINS = "/sbin/ipchains";
$IPFWADM = "/sbin/ipfwadm";

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
if (defined $pairs{'configure'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if (-e "./fw-init") {
    &RememberConfig;
  } else {
    &print_error("Couldn't find ./fw-init...");
  }
}    

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{"_submit_build"}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    if (!$pairs{'script_type'}) {
	&print_error("You must choose a script type...");
    } elsif ($pairs{'script_type'} eq "ipchains") {
	&BuildIpchainsScript;
    } else {
	&BuildIpfwadmScript;
    }

    &viewScript;

    # Build .config file for &RememberConfig();
    open(FD, ">.fwconfig");

    print (FD "script_type=\"$pairs{'script_type'}\"\n");
    print (FD "INTERNALIP=\"$pairs{'internalip'}\"\n");
    print (FD "EXTERNALIP=\"$pairs{'externalip'}\"\n");
    print (FD "LOOPBACK=\"$pairs{'loopback'}\"\n");
    print (FD "NETWORKIP=\"$pairs{'networkip'}\"\n");
    print (FD "dns=\"$pairs{'dns'}\"\n");
    print (FD "icmp=\"$pairs{'icmp'}\"\n");
    print (FD "logging=\"$pairs{'logging'}\"\n");
    print (FD "tcpin=\"$TCP_ALLOWIN\"\n");
    print (FD "tcpout=\"$TCP_ALLOWOUT\"\n");
    print (FD "tcpmasq=\"$MASQ_ALLOWIN\"\n");
    
    close(FD);
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{'install'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    `./fw-init`;
    print $fw_header;
    &FwStat;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{'viewscript'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    &viewScript;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{'status'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    print $fw_header;
    &FwStat;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{'uninstall'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    &FwOpen;
    print $fw_header;
    &FwStat;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
elsif (defined $pairs{'connections'}) {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    &PrintContentType;
    print $fw_header;
    &MasqWatch;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
else {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  &PrintContentType;
  &LoadHTML("fwconfig.html");
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub viewScript {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    print $fw_header;
    print "<pre>\n";
    &LoadHTML("fw-init");
    print "</pre>\n";
    print $button;
    print $fw_footer;
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub BuildIpfwadmScript {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # Open file for writing
    open(FD, ">fw-init");
    
    # Build script headers
    print (FD "#!/bin/sh\n");
    print (FD "# Firewall Script built for $pairs{'script_type'}\n");
    
    $TIME = scalar localtime;
    print (FD "# Script created $TIME\n\n");
    
    print (FD "# Set up variables\n");
    print (FD "INTERNALIP=\"$pairs{'internalip'}\"\n");
    print (FD "EXTERNALIP=\"$pairs{'externalip'}\"\n");
    print (FD "LOOPBACK=\"$pairs{'loopback'}\"\n");
    print (FD "NETWORKIP=\"$pairs{'networkip'}\"\n");
    print (FD "ANYWHERE=\"0.0.0.0/0\"\n");
    print (FD "PORTS=\"1024:65535\"\n\n");

    # Get values for TCP_ALLOWIN and print them
    if ($pairs{'inlist'}) {
      @invars = split(/~/,$pairs{'inlist'});

      foreach (@invars) {
        $TCP_ALLOWIN .= "$_ ";
      }
    }
    chop($TCP_ALLOWIN);
    print (FD "TCP_ALLOWIN=\"$TCP_ALLOWIN\"\n");

    # Get values for TCP_ALLOWOUT and print them
    if ($pairs{'outlist'}) {
      @outvars = split(/~/,$pairs{'outlist'});

      foreach (@outvars) {
        $TCP_ALLOWOUT .= "$_ ";
      }
    }
    chop($TCP_ALLOWOUT);
    print (FD "TCP_ALLOWOUT=\"$TCP_ALLOWOUT\"\n");

    # Get values for MASQ_ALLOWIN and print them
    if ($pairs{'masqlist'}) {
      @masqvars = split(/~/,$pairs{'masqlist'});

      foreach (@masqvars) {
	$MASQ_ALLOWIN .= "$_ ";
      }
    }
    chop($MASQ_ALLOWIN);
    print (FD "MASQ_ALLOWIN=\"$MASQ_ALLOWIN\"\n\n");

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($TCP_ALLOWIN) { # Setup TCP incoming rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Incoming Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -I -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -I -p deny\n\n" .
	       
	       "# Unlimited traffic within the local network\n" .
	       "$IPFWADM -I -a accept -V \"\$INTERNALIP\" -S " .
	       "\"\$NETWORKIP\" -D \"\$ANYWHERE\"\n\n");
	
	print (FD "# =====Deny spoofed packets and log denied requests\n" .
	       "$IPFWADM -I -a deny -V \"\$EXTERNALIP\" -S " .
	       "\"\$NETWORKIP\" -D \"\$ANYWHERE\" -o\n\n");
	
	if ($pairs{'logging'} =~ /all/) {
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN` ; do\n" .
		   "	  $IPFWADM -I -a accept -P tcp -V " .
		   "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		   "	    \"\$PORTS\" -D \"\$EXTERNALIP\" " .
		   "\"\$SERVICES\" -o \ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT` ; do\n" .
		   "      $IPFWADM -I -a accept -P tcp -S -V " .
		   "\"\$EXTERNALIP\" \"\$ANYWHERE\" \"\$SERVICES\" \\\n" .
		   "	-D \"\$EXTERNALIP\" \"\$PORTS\" -o " .
		   "\ndone\n\n");
	}
	else
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN` ; do\n" .
		   "      $IPFWADM -I -a accept -P tcp -V " .
		   "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		   "        \"\$PORTS\" -D \"\$EXTERNALIP\" " .
		   "\"\$SERVICES\" \ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT` ; do\n" .
		   "	$IPFWADM -I -a accept -P tcp -S " .
		   "\"\$ANYWHERE\" \"\$SERVICES\" \\\n" .
		   "	-D \"\$EXTERNALIP\" \"\$PORTS\" \ndone\n\n");
	}
	
	if ($pairs{'logging'} =~ /all/) 
	{
	    if (defined $pairs{'icmp'})
	    {
	        print (FD "# Allow ping requests\n");
	        print (FD "$IPFWADM -I -a accept -P icmp -V " .
		       "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		       "	-D \"\$EXTERNALIP\" -o\n\n");
	    }
	}
	else
	{
	    if (defined $pairs{'icmp'})
	    {
	        print (FD "# Allow ping requests\n");
	        print (FD "$IPFWADM -I -a accept -P icmp -V " .
		       "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		       "	-D \"\$EXTERNALIP\" \n\n");
	    }
	}
	
	if (defined $pairs{'dns'})
	{
	    print (FD "# DNS\n");
	    print (FD "$IPFWADM -I -a accept -P udp -V " .
		   "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		   "	-D \"\$EXTERNALIP\" \n");
	    
	    print (FD "$IPFWADM -I -a accept -V \"\$LOOPBACK\" " .
		   "-S \"\$ANYWHERE\" -D \"\$ANYWHERE\" \n\n");
	}
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPFWADM -I -a deny -S \"\$ANYWHERE\" " .
		   "-D \"\$ANYWHERE\" -o \n\n");
	}
    }
    else
    {
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Incoming Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -I -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -I -p deny\n\n");
    }
    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($TCP_ALLOWOUT) { # Setup TCP outgoing rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Outgoing Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -O -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -O -p deny\n\n" .
	       
	       "# Unlimited traffic within the local network\n" .
	       "$IPFWADM -O -a accept -V \"\$INTERNALIP\" -S " .
	       "\"\$ANYWHERE\" -D \"\$NETWORKIP\" \n\n");
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Logging\n");
	    print (FD
		   "$IPFWADM -O -a deny -V \"\$EXTERNALIP\" -S " .
		   "\"\$ANYWHERE\" -D \"\$NETWORKIP\" -o\n" .
		   "$IPFWADM -O -a deny -V \"\$EXTERNALIP\" -S " .
		   "\"\$NETWORKIP\" -D \"\$ANYWHERE\" -o\n\n");
	}
	
	if ($pairs{'logging'} =~ /all/)
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT`; do\n" .
		   "	$IPFWADM -O -a accept -P tcp -S " .
		   "\"\$EXTERNALIP\" \"\$PORTS\" \\\n" .
		   "	-D \"\$ANYWHERE\" \"\$SERVICES\" -o " .
		   "\n\ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN`; do\n" .
		   "	$IPFWADM -O -a accept -P tcp -S " .
		   "\"\$EXTERNALIP\" \"\$SERVICES\" \\\n" .
		   "	-D \"\$ANYWHERE\" \"\$PORTS\" -o \n" .
		   "done\n\n");
	}
	else
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT`; do\n" .
		   "	$IPFWADM -O -a accept -P tcp -S " .
		   "\"\$EXTERNALIP\" \"\$PORTS\" \\\n" .
		   "	-D \"\$ANYWHERE\" \"\$SERVICES\" \n\n" .
		   "done\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN`; do\n" .
		   "      $IPFWADM -O -a accept -P tcp -S " .
		   "\"\$EXTERNALIP\" \"\$SERVICES\" \\\n" .
		   "      -D \"\$ANYWHERE\" \"\$PORTS\" \n" .
		   "done\n\n");
	}
	if (defined $pairs{'dns'})
	{
	    print (FD "# DNS\n");
	    print (FD "$IPFWADM -O -a accept -P udp -V " .
		   "\"\$EXTERNALIP\" -S \"\$EXTERNALIP\" \\\n" .
		   "    -D \"\$ANYWHERE\" \n");
	    print (FD "$IPFWADM -O -a accept -V \"\$LOOPBACK\" " .
		   "-S \"\$ANYWHERE\" -D \"\$ANYWHERE\" \n\n");
	}
	
	if ($pairs{'logging'} =~ /all/) 
	{
	    if (defined $pairs{'icmp'})
	    {
	        print (FD "# Allow ping requests\n");
	        print (FD "$IPFWADM -O -a accept -P icmp -V " .
		       "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		       "	-D \"\$EXTERNALIP\" -o\n\n");
	    }
	}
	else
	{
	    if (defined $pairs{'icmp'})
	    {
	        print (FD "# Allow ping requests\n");
	        print (FD "$IPFWADM -O -a accept -P icmp -V " .
		       "\"\$EXTERNALIP\" -S \"\$ANYWHERE\" \\\n" .
		       "	-D \"\$EXTERNALIP\" \n\n");
	    }
	}
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPFWADM -O -a deny -S \"\$ANYWHERE\" -D " .
		   "\"\$ANYWHERE\" -o\n\n");
	}
    }
    else
    {
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Outgoing Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -O -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -O -p deny\n\n");
    }
    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($MASQ_ALLOWIN) { # Setup Masquerading rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  ======================================\n" .
	       "#  ========== Forwarded Rules ===========\n" .
	       "#  ======================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -F -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -F -p deny\n\n");
	
	if ($pairs{'logging'} =~ /all/) 
	{
		print (FD "for MSERVICES in `echo \$MASQ_ALLOWIN`; do\n" .
	       		"	$IPFWADM -F -a m -P tcp -S \"\$NETWORKIP\" " .
	       		"-D \"\$ANYWHERE\" \$MSERVICES -o\n" .
	       		"done\n\n");
	}
	else
	{
		print (FD "for MSERVICES in `echo \$MASQ_ALLOWIN`; do\n" .
	       		"	$IPFWADM -F -a m -P tcp -S \"\$NETWORKIP\" " .
	       		"-D \"\$ANYWHERE\" \$MSERVICES\n" .
	       		"done\n\n");
	}
	
	print (FD "# DNS\n");
	print (FD "$IPFWADM -F -a m -P udp -S \"\$NETWORKIP\" " .
	       "-D \"\$ANYWHERE\" domain\n\n");
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPFWADM -F -a deny -S \"\$ANYWHERE\" -D " .
		   "\"\$ANYWHERE\" -o\n");
	}
    }
    else
    {
	print (FD
	       "#  ======================================\n" .
	       "#  ========== Forwarded Rules ===========\n" .
	       "#  ======================================\n\n" .
	       
	       "# Flush previous rules\n" .
	       "$IPFWADM -F -f\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPFWADM -F -p deny\n\n");
    }
    close(FD);
    $cnt = chmod 0755, 'fw-init';
    if ($cnt <= 0) {
	&print_error("Couldn't change permissions of firewall script");
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub BuildIpchainsScript {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # Open file for writing
    open(FD, ">fw-init");
    
    # Build script headers
    print (FD "#!/bin/sh\n");
    print (FD "# Firewall Script built for $pairs{'script_type'}\n");
    
    $TIME = scalar localtime;
    print (FD "# Script created $TIME\n\n");
    
    print (FD "# Set up variables\n");
    print (FD "INTERNALIP=\"$pairs{'internalip'}\"\n");
    print (FD "EXTERNALIP=\"$pairs{'externalip'}\"\n");
    print (FD "LOOPBACK=\"$pairs{'loopback'}\"\n");
    print (FD "NETWORKIP=\"$pairs{'networkip'}\"\n");
    print (FD "ANYWHERE=\"0.0.0.0/0\"\n");
    print (FD "PORTS=\"1024:65535\"\n\n");

    print FD "# Flush chains\n";
    print FD "$IPCHAINS -F\n\n";

    # Get values for TCP_ALLOWIN and print them
    if ($pairs{'inlist'}) {
      @invars = split(/~/,$pairs{'inlist'});

      foreach (@invars) {
        $TCP_ALLOWIN .= "$_ ";
      }
    }
    chop($TCP_ALLOWIN);
    print (FD "TCP_ALLOWIN=\"$TCP_ALLOWIN\"\n");

    # Get values for TCP_ALLOWOUT and print them
    if ($pairs{'outlist'}) {
      @outvars = split(/~/,$pairs{'outlist'});

      foreach (@outvars) {
        $TCP_ALLOWOUT .= "$_ ";
      }
    }
    chop($TCP_ALLOWOUT);
    print (FD "TCP_ALLOWOUT=\"$TCP_ALLOWOUT\"\n");

    # Get values for MASQ_ALLOWIN and print them
    if ($pairs{'masqlist'}) {
      @masqvars = split(/~/,$pairs{'masqlist'});

      foreach (@masqvars) {
	$MASQ_ALLOWIN .= "$_ ";
      }
    }
    chop($MASQ_ALLOWIN);
    print (FD "MASQ_ALLOWIN=\"$MASQ_ALLOWIN\"\n\n");
    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($TCP_ALLOWIN) { # Setup TCP incoming rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Incoming Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P input DENY\n\n" .
	       
	       "# Unlimited traffic within the local network\n" .
	       "$IPCHAINS -A input -j ACCEPT -s " .
	       "\"\$NETWORKIP\" -d \"\$ANYWHERE\"\n\n");

         print FD "$IPCHAINS -A input -j ACCEPT -s \"\$ANYWHERE\" " .
	 	  "-i lo\n\n";
	
	if ($pairs{'logging'} =~ /all/) {
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN` ; do\n" .
		   "	  $IPCHAINS -A input -j ACCEPT -p tcp " .
		   "-s \"\$ANYWHERE\" \\\n" .
		   "	    \"\$PORTS\" -d \"\$EXTERNALIP\" " .
		   "\"\$SERVICES\" -l\ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT` ; do\n" .
		   "      $IPCHAINS -A input -j ACCEPT -p tcp -s " .
		   "\"\$ANYWHERE\" \"\$SERVICES\" \\\n" .
		   "	-d \"\$EXTERNALIP\" \"\$PORTS\" " .
		   "-l \ndone\n\n");
	}
	else
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN` ; do\n" .
		   "      $IPCHAINS -A input -j ACCEPT -p tcp " .
		   "-s \"\$ANYWHERE\" \\\n" .
		   "        \"\$PORTS\" -d \"\$EXTERNALIP\" " .
		   "\"\$SERVICES\" \ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT` ; do\n" .
		   "	$IPCHAINS -A input -j ACCEPT -p tcp -s " .
		   "\"\$ANYWHERE\" \"\$SERVICES\" \\\n" .
		   "	-d \"\$EXTERNALIP\" \"\$PORTS\" " .
		   "\ndone\n\n");
	}

	print (FD "# Allow packets to \$PORTS only if connection\n" .
	       "# originated from our network (only if ack bit is set)\n" .
	       "$IPCHAINS -A input -j ACCEPT -p tcp ! -y -s " .
	       "\"\$ANYWHERE\" \"\$PORTS\" \\\n" .
	       "        -d \"\$EXTERNALIP\" \"\$PORTS\" \n\n");
	
	if (defined $pairs{'icmp'})
	{
	    print (FD "# Allow ping requests\n");
	    print (FD "$IPCHAINS -A input -j ACCEPT -p icmp\n\n");
	}
	
	if (defined $pairs{'dns'})
	{
	    print (FD "# DNS\n");
	    print (FD "$IPCHAINS -A input -j ACCEPT -p udp " .
		   "-s \"\$ANYWHERE\" \\\n" .
		   "	domain\n");
	}
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPCHAINS -A input -j DENY -s \"\$ANYWHERE\" " .
		   "-d \"\$ANYWHERE\" -l\n\n");
	}
    }
    else
    {
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Incoming Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P input DENY\n\n");
    }
    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($TCP_ALLOWOUT) { # Setup TCP outgoing rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Outgoing Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P output DENY\n\n" .
	       
	       "# Unlimited traffic within the local network\n" .
	       "$IPCHAINS -A output -j ACCEPT -s " .
	       "\"\$ANYWHERE\" -d \"\$NETWORKIP\" \n\n");
	
	if ($pairs{'logging'} =~ /all/)
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT`; do\n" .
		   "	$IPCHAINS -A output -j ACCEPT -p tcp -s " .
		   "\"\$EXTERNALIP\" \"\$PORTS\" \\\n" .
		   "	-d \"\$ANYWHERE\" \"\$SERVICES\" -l " .
		   "\n\ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN`; do\n" .
		   "	$IPCHAINS -A output -j ACCEPT -p tcp -s " .
		   "\"\$EXTERNALIP\" \"\$SERVICES\" \\\n" .
		   "	-d \"\$ANYWHERE\" \"\$PORTS\" -l \n" .
		   "done\n\n");
	}
	else
	{
	    print (FD "# Target\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWOUT`; do\n" .
		   "	$IPCHAINS -A output -j ACCEPT -p tcp -s " .
		   "\"\$EXTERNALIP\" \"\$PORTS\" \\\n" .
		   "	-d \"\$ANYWHERE\" \"\$SERVICES\" " .
		   "\n\ndone\n\n");
	    
	    print (FD "# Return\n");
	    print (FD "for SERVICES in `echo \$TCP_ALLOWIN`; do\n" .
		   "	$IPCHAINS -A output -j ACCEPT -p tcp -s " .
		   "\"\$EXTERNALIP\" \"\$SERVICES\" \\\n" .
		   "	-d \"\$ANYWHERE\" \"\$PORTS\"\n" .
		   "done\n\n");
	}

	if (defined $pairs{'dns'})
	{
	    print (FD "# DNS\n");
	    print (FD "$IPCHAINS -A output -j ACCEPT -p udp " .
		   "-s \"\$EXTERNALIP\" \\\n" .
		   "    -d \"\$ANYWHERE\" \n");
	    print (FD "$IPCHAINS -A output -j ACCEPT " .
		   "-s \"\$ANYWHERE\" -d \"\$ANYWHERE\" \n\n");
	}
	
	if (defined $pairs{'icmp'})
	{
	    print (FD "# Allow ping requests\n");
	    print (FD "$IPCHAINS -A output -j ACCEPT -p icmp\n\n");
	}
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPCHAINS -A output -j DENY -s \"\$ANYWHERE\" -d " .
		   "\"\$ANYWHERE\" -l\n\n");
	}
    }
    else
    {
	print (FD
	       "#  =====================================\n" .
	       "#  ========== Outgoing Rules ===========\n" .
	       "#  =====================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P output DENY\n\n");
    }
    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ($MASQ_ALLOWIN) { # Setup Masquerading rules
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	print (FD
	       "#  ======================================\n" .
	       "#  ========== Forwarded Rules ===========\n" .
	       "#  ======================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P forward DENY\n\n");
	
	if ($pairs{'logging'} =~ /all/)
	{
		print (FD "for MSERVICES in `echo \$MASQ_ALLOWIN`; do\n" .
	       		"	$IPCHAINS -A forward -j MASQ -p tcp -s " .
	       		"\"\$NETWORKIP\" -d \"\$ANYWHERE\" \$MSERVICES -l\n" .
	       		"done\n\n");
	}
	else
	{
		print (FD "for MSERVICES in `echo \$MASQ_ALLOWIN`; do\n" .
	       		"	$IPCHAINS -A forward -j MASQ -p tcp -s " .
	       		"\"\$NETWORKIP\" -d \"\$ANYWHERE\" \$MSERVICES\n" .
	       		"done\n\n");
	}
	
	print (FD "# DNS\n");
	print (FD "$IPCHAINS -A forward -j MASQ -p udp -s " .
		"\"\$NETWORKIP\" -d \"\$ANYWHERE\" domain\n\n");
	
	if (defined $pairs{'logging'})
	{
	    print (FD "# Log the rest\n");
	    print (FD "$IPCHAINS -A forward -j DENY -s " .
	   	"\"\$ANYWHERE\" -d \"\$ANYWHERE\" -l\n");
	}
    }
    else
    {
	print (FD
	       "#  ======================================\n" .
	       "#  ========== Forwarded Rules ===========\n" .
	       "#  ======================================\n\n" .
	       
	       "# Set default policy to deny\n" .
	       "$IPCHAINS -P forward DENY\n\n");
    }
    close(FD);
    $cnt = chmod 0755, 'fw-init';
    if ($cnt <= 0) {
	&print_error("Couldn't change permissions of firewall script");
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub FwStat {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # Open fwconfig config file to get script type
    open(FD, ".fwconfig")
      || &print_error("Couldn't open firewall config file: $!");

    $script_type = <FD>;
    chop($script_type);
    @condition = split(/=/, $script_type);
    $condition[1] =~ s/"//g;
    close(FD);

    if ($condition[1] eq "ipchains") {
	$ipdata = `$IPCHAINS -L -n`;

        print "<pre>\n";
        print "====================================\n";
        print "========== Firewall rules ==========\n";
        print "====================================\n";
        print "$ipdata";
        print "</pre><br><br>\n";
    } 
    else {
	$ipIdata = `$IPFWADM -I -l -n`;
	$ipOdata = `$IPFWADM -O -l -n`;
	$ipFdata = `$IPFWADM -F -l -n`;

        print "<pre>\n";
        print "====================================\n";
        print "========== Incoming rules ==========\n";
        print "====================================\n";
        print "$ipIdata";
        print "\n";
        print "====================================\n";
        print "========== Outgoing rules ==========\n";
        print "====================================\n";
        print "$ipOdata";
        print "\n";
        print "====================================\n";
        print "========== Forwarded rules =========\n";
        print "====================================\n";
        print "$ipFdata";
        print "</pre><br><br>\n";
    }
    
    print "$button";
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub FwOpen {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # Open fwconfig config file to get script type
    open(FD, ".fwconfig")
      || &print_error("Couldn't open firewall config file: $!");

    $script_type = <FD>;
    chop($script_type);
    @condition = split(/=/, $script_type);
    $condition[1] =~ s/"//g;
    close(FD);
    
    if ($condition[1] eq "ipchains") {
	`$IPCHAINS -F`;
	`$IPCHAINS -P input ACCEPT`;
	`$IPCHAINS -P output ACCEPT`;
	`$IPCHAINS -P forward ACCEPT`;
    } else {
	`$IPFWADM -I -f`;
	`$IPFWADM -I -p accept`;
	`$IPFWADM -O -f`;
	`$IPFWADM -O -p accept`;
	`$IPFWADM -F -f`;
	`$IPFWADM -F -p accept`;
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub RememberConfig {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  $i = 0;
  &PrintContentType;

  open(FD, ".fwconfig") 
    || &print_error("Couldn't open firewall config file: $!");
  while(<FD>) {
    chop;
    $line[$i++] = $_;
  }
  close(FD);

  $line[0] =~ s/^.*="//g; chop($line[0]);
  $script_type = $line[0];

  $line[1] =~ s/^.*="//g; chop($line[1]);
  $internal_ip = $line[1];

  $line[2] =~ s/^.*="//g; chop($line[2]);
  $external_ip = $line[2];

  $line[3] =~ s/^.*="//g; chop($line[3]);
  $loopback_ip = $line[3];

  $line[4] =~ s/^.*="//g; chop($line[4]);
  $network_ip = $line[4];

  $line[5] =~ s/^.*="//g; chop($line[5]);
  $dns = $line[5];

  $line[6] =~ s/^.*="//g; chop($line[6]);
  $icmp = $line[6];

  $line[7] =~ s/^.*="//g; chop($line[7]);
  $logging = $line[7];

  $line[8] =~ s/^.*="//g; chop($line[8]);
  $tcpin = $line[8];

  $line[9] =~ s/^.*="//g; chop($line[9]);
  $tcpout = $line[9];

  $line[10] =~ s/^.*="//g; chop($line[10]);
  $tcpmasq = $line[10];

  print "<HTML>\n";
  print "<HEAD>\n";
  print "</HEAD>\n";
  print "<body text=\"white\" bgcolor=\"black\" LINK=\"#AAAAAA\" VLINK=" .
	"\"#AAAAAA\" ALINK=\"#AAAAAA\">\n";
  print "\n";
  print "<center><font face=\"charcoal\" size=5>fwconfig-1.5</font>" .
	"</center>\n";
  print "<center><font face=\"charcoal\" size=5>Configuration</font></" .
	"center>\n";
  print "<br>\n";
  print "<FORM METHOD=\"POST\" ACTION=\"fwconfig.pl\">\n";
  print "<center>\n";
  print "<table border=1><tr>\n";

  if ($script_type eq "ipchains") {
    print "<td>Create Script using ipchains:</td><td><input type=\"radio\" \n";
    print " name=\"script_type\" value=\"ipchains\" checked></td></tr><tr>\n";
    print "<td>Create script using ipfwadm:</td><td> <input type=\"radio\" \n";
    print " name=\"script_type\" value=\"ipfwadm\"></td></tr></table>\n";
  } else {
    print "<td>Create Script using ipchains:</td><td><input type=\"radio\" \n";
    print " name=\"script_type\" value=\"ipchains\"></td></tr><tr>\n";
    print "<td>Create script using ipfwadm:</td><td> <input type=\"radio\" \n";
    print " name=\"script_type\" value=\"ipfwadm\" checked></td></tr>" .
	  "</table>\n";
  }
  print "<br>\n";
  print "<table border=1><tr>\n";
  print "<td>\n";
  print "EXTERNAL IP ADDRESS:</td><td> <INPUT TYPE=\"text\" NAME=\"ext" .
	"ernalip\" value=\"$external_ip\" SIZE=15>\n";
  print "</td></tr><tr><td>\n";
  print "INTERNAL IP ADDRESS:</td><td> <INPUT TYPE=\"text\" NAME=\"int" .
	"ernalip\" value=\"$internal_ip\" SIZE=15>\n";
  print "</td></tr><tr><td>\n";
  print "LOOPBACK IP ADDRESS:</td><td> <INPUT TYPE=\"text\" NAME=\"loo" .
	"pback\" value=\"$loopback_ip\" SIZE=15>\n";
  print "</td></tr><tr><td>\n";
  print "NETWORK ADDRESS:</td><td> <INPUT TYPE=\"text\" NAME=\"network" .
	"ip\" value=\"$network_ip\" SIZE=15>\n";
  print "</td></tr></table>\n";
  print "<center>\n";
  print "<br>\n";
  print "<center>\n";
  print "<table><tr><td>\n";

  print "Choose allowable incoming services.<br>\n";

  &BuildServiceList($tcpin, inlist);

  print "</td><td>\n";

  print "Choose allowable outgoing services.<br>\n";

  &BuildServiceList($tcpout, outlist);

  print "</td></tr></table>\n";
  print "</center>\n";

  print "<br>\n";
  print "<br>\n";

  print "<table border=1><tr>\n";
  print "<td>DNS</td><td>ICMP</td><td>Logging</td></tr><td>\n";
  print "<table border=1><tr>\n";

  if ($dns) {
    print "<td>DNS/PORT 53 (UDP)</td><td> <INPUT TYPE=\"checkbox\" NAME=\"dns" .
          "\" VALUE=\"domain\" checked>\n";
  } else {
    print "<td>DNS/PORT 53 (UDP)</td><td> <INPUT TYPE=\"checkbox\" NAME=\"dns" .
          "\" VALUE=\"domain\">\n";
  }
  print "</td></tr></table>\n";
  print "\n";
  print "</td><td>\n";
  print "<table border=1><tr>\n";

  if ($icmp) {
    print "<td>ICMP</td><td><INPUT TYPE=\"checkbox\" NAME=\"icmp\" VALUE" .
          "=\"icmp\" checked>\n";
  } else {
    print "<td>ICMP</td><td><INPUT TYPE=\"checkbox\" NAME=\"icmp\" VALUE" .
          "=\"icmp\">\n";
  }
  print "</td></tr></table>\n";
  print "\n";
  print "</td><td>\n";
  print "<table border=1><tr>\n";

  if ($logging eq "denied") {
    print "<td>Denied Requests</td><td><INPUT TYPE=\"radio\" NAME=\"log" .
          "ging\" VALUE=\"denied\" checked>\n";

  print "</td></tr>\n";

    print "<td>All Requests</td><td><INPUT TYPE=\"radio\" NAME=\"loggin" .
          "g\" VALUE=\"all\">\n";
  } else {
    print "<td>Denied Requests</td><td><INPUT TYPE=\"radio\" NAME=\"log" .
          "ging\" VALUE=\"denied\">\n";

  print "</td></tr>\n";

    print "<td>All Requests</td><td><INPUT TYPE=\"radio\" NAME=\"loggin" .
          "g\" VALUE=\"all\" checked>\n";
  }

  print "\n";
  print "</td></tr></table>\n";
  print "\n";
  print "</td></tr></table>\n";
  print "<br>\n";
  print "<br>\n";


  print "You can create your firewall now<br>\n";
  print "<INPUT TYPE=\"submit\" name=\"_submit_build\" VALUE=\"Create " .
	"Firewall\">\n";
  print "<br>or continue on by setting up masquerading rules.\n";
  print "<hr width=\"40%\">\n";
  print "<br>\n";

  print "Services for IP Masquerade\n";
  print "<table><tr><td>\n";

  &BuildServiceList($tcpmasq, masqlist);

  print "</td></tr></table>\n";
  print "<br>\n";
  print "<center>\n";
  print "<INPUT TYPE=\"submit\" name=\"_submit_build\" VALUE=\"Create " .
	"Firewall\">\n";
  print "</center>\n";
  print "</form>\n";
  
  print "</body>\n";
  print "</html>\n";
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub MasqWatch {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # Open firewall config file to get script type
  open(FD, ".fwconfig") 
    || &print_error("Couldn't open firewall config file: $!");

  $script_type = <FD>;
  chop($script_type);
  @condition = split (/=/, $script_type);
  $condition[1] =~ s/"//g;
  close(FD);

  if ($condition[1] =~ /ipchains/) {
    $masq_data = `$IPCHAINS -M -L`; 
  } else {
    $masq_data = `$IPFWADM -M -l`; 
  }

  print "<html>\n";
  print "<head><title>Masqueraded entries...</title>\n";
  print "<META http-equiv=\"refresh\"" .
  	"content=\"25; URL=fwconfig.pl?connections=1\">\n";
  print "</head>\n";
  print "<body text=\"white\" bgcolor=\"black\" link=\"#AAAAAA\" " .
        "vlink=\"#AAAAAA\" alink=\"#AAAAAA\">\n";
  print "<pre>\n";
  print "Updates take place every 25 seconds.\n";
  print "<hr width=70% align=left>";
  print "$condition[1]: $masq_data\n\n";
  print "</pre>\n";
  print "<form>\n";
  print "$button";
  print "</body></html>\n";
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub BuildServiceList {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  my $servicename = shift;
  my $listname = shift;
  my $i = 0;
  my $name;
  my $port;
  open (FD, "/etc/services")
	|| &print_error("Couldn't open /etc/services: $!");

  while (<FD>) {
    next if ($_ =~ /^#/ || $_ =~ /^\s+/);
    $service_ary[$i++] = $_;
  } 

  print "<select multiple size=\"10\" name=\"$listname\">\n";
  foreach (@service_ary) {
    $_ =~ s/\s+/ /g;
    ($name, $port) = split(/ /, $_);
    next if ($port !~ /tcp/);

    if ($servicename =~ /\b$name/) { 
      print "<option value=\"$name\" selected>$name -> $port\n";
    } else {
      print "<option value=\"$name\">$name -> $port\n";
    }
  }
  print "</select>\n";
}
